#ifndef __a320_sound_h__
#define __a320_sound_h__

#define A320_SAMPLE_RATE 22050
#define A320_SNDLENGTH   1024
#define A320_MIXCHANNELS 4

#include "config.h"

typedef struct {
  int16_t  *sndbuf;
	int16_t  *buf;
	uint32_t len;
	uint32_t index;
	int8_t   loop;
} a320_channel_t;


#ifdef GEMEI760
#define VOLUME_MAX 100
#define VOLUME_STEP 10
#define VOLUME_INIT 40
#else
#define VOLUME_MAX 30
#define VOLUME_STEP 3
#define VOLUME_INIT 12
#endif

extern int a320_sound_level;

extern void a320_sound_endchannel(uint8_t chan);

extern void a320_sound_init(void);
extern void a320_sound_stop(void);
extern void a320_sound_pause(int yes);
extern void a320_sound_increase(void);
extern void a320_sound_decrease(void);

extern void a320_sound_modstop(void);
extern void a320_sound_modplay(unsigned int len, unsigned char *pMod);
extern void a320_sound_xmplay(unsigned int len, unsigned char *pMod);
extern  int a320_sound_modgetstat(void);
extern  int a320_sound_getofsstatus(void);

extern void a320_sound_wavplay(void* buffer, unsigned int size, unsigned int repeat, unsigned int freq);
extern void a320_sound_wavstop(uint8_t chan);

#endif
