#include <stdlib.h>
#include <slcd.h>
#include <cache.h>
#include "display.h"

unsigned short* g_pGameDecodeBuf = NULL;

void* display_addr() {
	return g_pGameDecodeBuf;
}

void display_clear(uint8_t inRed, uint8_t inGreen, uint8_t inBlue) {
	uint32_t* tempPtr = display_addr();
	uint32_t* tempEnd = (uint32_t*)((uintptr_t)tempPtr + (display_width * display_height << 1));
	uint32_t  tempColor = (inBlue >> 3) | ((inGreen & 0xFC) << 3) | ((inRed & 0xF8) << 10);
	tempColor |= (tempColor << 16);
	while(tempPtr < tempEnd) {
		*(tempPtr++) = tempColor;
		*(tempPtr++) = tempColor;
		*(tempPtr++) = tempColor;
		*(tempPtr++) = tempColor;
		*(tempPtr++) = tempColor;
		*(tempPtr++) = tempColor;
		*(tempPtr++) = tempColor;
		*(tempPtr++) = tempColor;
	}
}

void display_flip() {
	uint32_t* tempDispBuff = (uint32_t*) _lcd_get_frame();
	uint32_t* tempDrawBuff = (uint32_t*)g_pGameDecodeBuf;
	uint32_t* tempDispEnd  = (uint32_t*)((uintptr_t)tempDispBuff + (display_width * display_height * 2));
	while(tempDispBuff < tempDispEnd) {
		*(tempDispBuff++) = *(tempDrawBuff++);
		*(tempDispBuff++) = *(tempDrawBuff++);
		*(tempDispBuff++) = *(tempDrawBuff++);
		*(tempDispBuff++) = *(tempDrawBuff++);
		*(tempDispBuff++) = *(tempDrawBuff++);
		*(tempDispBuff++) = *(tempDrawBuff++);
		*(tempDispBuff++) = *(tempDrawBuff++);
		*(tempDispBuff++) = *(tempDrawBuff++);
	}
	__dcache_writeback_all();
	_lcd_set_frame();
}
