#include <stdlib.h>
#include <stdio.h>
#include <fsys.h>
#include <string.h>
#include <stdbool.h>
#include <stdint.h>
#include <ucos2.h>
#include <entry.h>

#include <time.h>

#include "lib/graphics.h"
#include "lib/display.h"
#include "lib/control.h"
#include "lib/timer.h"
#include "lib/fixmath.h"
#include "lib/a320_snd.h"

#include "../data/DIE_WAV.h"
#include "../data/PICK_WAV.h"
#include "../data/JUMP_WAV.h"

#include "../data/FINAL_XM.h"
#include "../data/INGAME_XM.h"
#include "../data/LASTFIRST_XM.h"
#include "../data/OPTIONS_XM.h"
#include "../data/ORIGINAL_XM.h"
#include "../data/TITLE_XM.h"

#define SYSVID_WIDTH  320
#define SYSVID_HEIGHT 240

unsigned short Xbuf16[SYSVID_WIDTH*SYSVID_HEIGHT];
unsigned char XBuf[SYSVID_WIDTH*SYSVID_HEIGHT];
//unsigned short Xbuf16_1[SYSVID_WIDTH*SYSVID_HEIGHT];
//unsigned char XBuf_1[SYSVID_WIDTH*SYSVID_HEIGHT];
unsigned char *screen;
unsigned short *screen16;

timer*   gameTimer    = NULL;
uint32_t gameTickRate = (timer_resolution / 30);
uint32_t tempTick  = 0;
uint32_t tempPauseOS = 0;

///////////////////////////////////////////////////////////////
//	Globals
///////////////////////////////////////////////////////////////
typedef	unsigned int	DWORD;
typedef	unsigned short	WORD;
typedef	unsigned char	BYTE;

int	SCXOFF;
int	SCYOFF;
//int	yoff[400];

BYTE		KeyTable[256];

BYTE	page;

WORD  FrCt;
WORD	NEXTBIT=0;

BYTE	bright[]= {0,1,2,3,4,5,6,7,8,7,6,5,4,3,2,1};
BYTE	bright2[]={0,1,2,3,4,3,2,1,0,1,2,3,4,3,2,1};

#define	KONGPAUSE	8

BYTE	PALwhite[768];
BYTE	PALblack[768];
BYTE	PALfade[768];
BYTE	PALover[768];
BYTE	PALact[768];

///////////////////////////////////////////////////////////////
//	Current Map Info
///////////////////////////////////////////////////////////////

BYTE	cMAP[512];
BYTE	cCRUMB[512];
BYTE	cTITLE[33];

BYTE	cBGink;
BYTE	cBGpaper;

BYTE	cPLAT1ink;
BYTE	cPLAT1paper;

BYTE	cPLAT2ink;
BYTE	cPLAT2paper;

BYTE	cWALLink;
BYTE	cWALLpaper;

BYTE	cCRUMBink;
BYTE	cCRUMBpaper;

BYTE	cKILL1ink;
BYTE	cKILL1paper;

BYTE	cKILL2ink;
BYTE	cKILL2paper;

BYTE	cCONVink;
BYTE	cCONVpaper;

BYTE	cBORDER;

BYTE	cPLAT1gfx;
BYTE	cPLAT2gfx;
BYTE	cWALLgfx;
BYTE	cCRUMBgfx;
BYTE	cKILL1gfx;
BYTE	cKILL2gfx;
BYTE	cCONVgfx;
BYTE	cEXITgfx;
BYTE	cKEYgfx;

WORD	cWILLYx;
WORD	cWILLYy;
WORD	cWILLYxold[2];
WORD	cWILLYyold[2];
WORD	cWILLYf;
BYTE	cWILLYd;
BYTE	cWILLYm;
BYTE	cWILLYj;
BYTE	cWILLYbuff[2][256];
WORD	cWILLYjp[]={4,4,3,3,2,2,1,1,0,0,1,1,2,2,3,3,4,4};
WORD	cWILLYfall;
WORD	cWILLYjs;
BYTE	cWILLYcol[128][256];

WORD	cCONVx;
WORD	cCONVy;
BYTE	cCONVd;
BYTE	cCONVl;
BYTE	cCONVf;
BYTE	cCONVm;
BYTE	cCONV1;

WORD	cKEYx[5];
WORD	cKEYy[5];
BYTE	cKEYb[5];
BYTE	cKEYs[5];

WORD	cSWITCHx[2];
WORD	cSWITCHy[2];
BYTE	cSWITCHs[2];

WORD	cEXITx;
WORD	cEXITy;
BYTE	cEXITb;
BYTE	cEXITm;

BYTE	cAIR;
BYTE	cAIRp;

BYTE	cHROBOink[4];
BYTE	cHROBOpaper[4];
WORD	cHROBOx[4];
WORD	cHROBOy[4];
WORD	cHROBOmin[4];
WORD	cHROBOmax[4];
BYTE	cHROBOd[4];
BYTE	cHROBOs[4];
WORD	cHROBOgfx[4];
BYTE	cHROBOflip[4];
BYTE	cHROBOanim[4];
WORD	cHROBOxold[4][2];
WORD	cHROBOyold[4][2];

BYTE	cVROBOink[4];
BYTE	cVROBOpaper[4];
WORD	cVROBOx[4];
WORD	cVROBOy[4];
WORD	cVROBOmin[4];
WORD	cVROBOmax[4];
BYTE	cVROBOd[4];
BYTE	cVROBOs[4];
WORD	cVROBOgfx[4];
BYTE	cVROBOanim[4];
WORD	cVROBOxold[4][2];
WORD	cVROBOyold[4][2];

///////////////////////////////////////////////////////////////
//	Special Robots
///////////////////////////////////////////////////////////////

WORD	EUGENEx;
WORD	EUGENEy;
WORD	EUGENEmin;
WORD	EUGENEmax;
BYTE	EUGENEd;
BYTE	EUGENEm;
BYTE	EUGENEc;
WORD	EUGENExold[2];
WORD	EUGENEyold[2];

BYTE	SWITCH1m;
BYTE	SWITCH2m;

WORD	HOLEy;
BYTE	HOLEl;

WORD	KONGx;
WORD	KONGy;
WORD	KONGxold[2];
WORD	KONGyold[2];
WORD	KONGmax;
BYTE	KONGm;
BYTE	KONGc;
BYTE	KONGf;
BYTE	KONGp;

WORD	SKYx[3];
WORD	SKYy[3];
WORD	SKYmax[3];
WORD	SKYxold[3][2];
WORD	SKYyold[3][2];
BYTE	SKYs[3];
BYTE	SKYf[3];
BYTE	SKYm[3];
BYTE	SKYc[3];
BYTE	SKYp[3];

BYTE	DEATHm;
WORD	DEATHc;

WORD	BOOTy;

WORD	SUNy;
BYTE	SUNm;
BYTE	SUNh;
BYTE	SUNbuff[2][384];
WORD	SUNyold[2];
BYTE	SUNhold[2];

///////////////////////////////////////////////////////////////
//	Solar Power Generator
///////////////////////////////////////////////////////////////

WORD	SPGx[2][64];
WORD	SPGy[2][64];

///////////////////////////////////////////////////////////////
//	Game Globals
///////////////////////////////////////////////////////////////

unsigned int	SCORE;
unsigned int	HISCORE=0;
unsigned int	EXTRA;
unsigned int	EXTRAdelta=10000;
BYTE		EXTRAm;
BYTE		EXTRAc;

WORD	LIVES;
BYTE	LIVESf;
BYTE	LIVESp;
BYTE	LEVEL=0;

BYTE	MUSICon=1;

BYTE	old=0;

BYTE	SPEED=2;

BYTE	MODE=3;
BYTE	GAMEm=0;

BYTE	DEMOm=0;
BYTE	DEMOp;

BYTE	TITLEm=0;
BYTE	TITLEwf;
BYTE	TITLEwp;

BYTE	OVERm=0;
BYTE	OVERink;
BYTE	OVERp;

BYTE	INK=7;
BYTE	PAPER=0;

BYTE	CHEAT=0;
BYTE	CHEATp=0;
BYTE	CHEATh;
BYTE	CHEATkey[]={9,11,3,10,3,7};

BYTE	PAUSE;
BYTE	LASTm;
WORD	LASTc;
BYTE	LASTp;
WORD	WINDOW[]={1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16};

BYTE	TEXTm;
WORD	TEXTpause;
BYTE	TEXTpoint;
BYTE	TEXTink;
BYTE	TEXTfade;

///////////////////////////////////////////////////////////////

BYTE	PIANOkhit[32];
BYTE	PIANOkey[]={0,1,1,2,0,1,2,0,1,1,2,0,1,2,0,1,2,0,1,1,2,0,1,2,0,1,1,2,0,1,2,3};
WORD	PIANOc;
BYTE	PIANObodge1;
BYTE	PIANObodge2;
BYTE	PIANObodgep;
BYTE	PIANObodgep2;

BYTE	SCROLLbuff[]="                                 ";
WORD	SCROLLpos;
BYTE	PIXELbuff[264*8];
WORD	PIXELoff;

BYTE	LOADm;
DWORD  LOADp;

BYTE	PREFSm;
BYTE	PREFSh1;
BYTE	PREFSh2;
BYTE	PREFSh3;

BYTE	CHAN[]={0,1,2,8,9,10,16,17,18};


///////////////////////////////////////////////////////////////
//	Tales from a Parallel Universe
///////////////////////////////////////////////////////////////

BYTE	TONKS=0;

BYTE MUSICtype;

///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////
void bitmap_scale(void) {
  uint16_t* buffer_scr = gfx_render_target->address;
  unsigned int W,H,ix,iy,x,y;
  x=SCXOFF<<16;
  y=SCYOFF<<16;
  W=320;
  H=240;
  ix=(256<<16)/W;
  iy=(192<<16)/H;

  do   
  {
    uint16_t *buffer_mem=&screen16[(y>>16)*320];
    W=320; x=SCXOFF<<16;
    do {
      WORD palIndex= buffer_mem[x>>16];
      *buffer_scr++=gfx_color_rgb(PALact[palIndex],PALact[palIndex+1],PALact[palIndex+2]);
      x+=ix;
    } while (--W);
    y+=iy;
  } while (--H);
}

#define GF_TITLES     0
#define GF_DEMO       1
#define GF_GAME       2
#define GF_LOADING    3
#define GF_QUIT       4

///////////////////////////////////////////////////////////////
//	Revision Number
///////////////////////////////////////////////////////////////
BYTE	VERSION[]={"V1.10"};

///////////////////////////////////////////////////////////////
//	Includes
///////////////////////////////////////////////////////////////
#include	"game/gfx/mm-pal.c"

#include	"game/gfx/mm-blocx.c"
#include	"game/gfx/mm-conv.c"
#include	"game/gfx/mm-exits.c"
#include	"game/gfx/mm-keys2.c"
#include	"game/gfx/mm-tplat.c"
#include	"game/gfx/mm-air.c"
#include  "game/gfx/mm-hrob2.c"
#include	"game/gfx/mm-vrobo.c"
#include	"game/gfx/mm-final.c"
#include	"game/gfx/mm-swit.c"
#include	"game/gfx/mm-font.c"
#include	"game/gfx/mm-fant.c"
#include	"game/gfx/mm-over.c"

#include	"game/gfx/mm-eug2.c"
#include	"game/gfx/mm-kong.c"
#include	"game/gfx/mm-sky.c"
#include	"game/gfx/mm-sun.c"
#include	"game/gfx/mm-fill.c"
#include	"game/gfx/mm-piano.c"
#include	"game/gfx/mm-pkeys.c"
#include	"game/gfx/mm-load.c"

#include	"game/gfx/mm-willy.c"
#include	"game/gfx/mm-ftsml.c"

#include	"game/gfx/mm-house.c"
#include	"game/gfx/mm-win.c"

#include	"game/mm-keydf.c"
#include	"game/mm-map2.c"
#include	"game/mm-end.c"

#include "game/manic.c"

int main(int argc, char** argv) {
  int ref = EXIT_SUCCESS;
  srand(OSTimeGet());

  control_init();
  control_lock(timer_resolution / 4);
  gfx_init();
  gfx_render_target_clear(gfx_color_rgb(0x00, 0x00, 0x00));
  gfx_render_target_swap();

  gameTimer   = a320_timer_create();

  a320_sound_init();
	
  MODE = GF_LOADING;
  LoadInfo();

	PaletteSet(PALmain);

	LOADm=0;
  screen = XBuf;
  screen16 = Xbuf16;
  page = 0;
  FrCt = 0;
  
  SCXOFF=32;
  SCYOFF=24;

//  int sysref;
		  
  while (MODE != GF_QUIT) {
/*
  	sysref = _sys_judge_event(NULL);
    if (sysref < 0) {
       break;  
    }
*/  
    
    switch (MODE) {
      case GF_TITLES:
        Titles(); 
        break;
		 
      case GF_DEMO:
        DoDemo();
        break;

      case GF_LOADING:
        DoLoading();
        break;
		
      case GF_GAME:
        DoGame();
        break;
    }

    control_poll();
    KeyTable[key_q] = 0;
    KeyTable[key_w] = 0;
    KeyTable[key_z] = 0;
    KeyTable[key_a] = 0;
    KeyTable[key_esc] = 0;
    KeyTable[key_return] = 0;
    KeyTable[key_f1] = 0;
    KeyTable[key_f3] = 0;
    KeyTable[key_f4] = 0;
    if (control_check(CONTROL_DPAD_LEFT).pressed) { KeyTable[key_q] = 1; }
    if (control_check(CONTROL_DPAD_RIGHT).pressed) { KeyTable[key_w] = 1; }
    if (control_check(CONTROL_DPAD_UP).pressed && control_check(CONTROL_DPAD_UP).changed ) { a320_sound_increase(); }
    if (control_check(CONTROL_DPAD_DOWN).pressed && control_check(CONTROL_DPAD_DOWN).changed ) { a320_sound_decrease(); }
    
    if (control_check(CONTROL_BUTTON_A).pressed || control_check(CONTROL_BUTTON_B).pressed ) { KeyTable[key_z] = 1; }
    if (control_check(CONTROL_BUTTON_X).pressed  && control_check(CONTROL_BUTTON_X).changed )  { KeyTable[key_esc] = 1; }
    if (control_check(CONTROL_BUTTON_Y).pressed  && control_check(CONTROL_BUTTON_Y).changed )  { KeyTable[key_f4] = 1; }
    
    if (control_check(CONTROL_TRIGGER_RIGHT).pressed  && control_check(CONTROL_TRIGGER_RIGHT).changed ) { KeyTable[key_a] = 1; }
    if (control_check(CONTROL_TRIGGER_LEFT).pressed  && control_check(CONTROL_TRIGGER_LEFT).changed ) {  KeyTable[key_f3] = 1; }
/*    
		if (control_check(CONTROL_TRIGGER_LEFT).pressed  && control_check(CONTROL_TRIGGER_LEFT).changed ) {
      static int SnapNb = 0;
      char szSnap[64];
		  SnapNb++;
		  sprintf(szSnap,"A:\\mm%d.tga",SnapNb);
		  gfx_texture toto;
		  toto.address = (unsigned short *)(gfx_render_target->address);
		  toto.width = 320;
		  toto.height = 240;
      a320_mod_stop();
		  gfx_tex_save_tga(szSnap, &toto) ;
		}
*/
    if (control_check(CONTROL_BUTTON_START).pressed  && control_check(CONTROL_BUTTON_START).changed )  { KeyTable[key_return] = 1; }
    if (control_check(CONTROL_BUTTON_SELECT).pressed  && control_check(CONTROL_BUTTON_SELECT).changed  ) { KeyTable[key_f1] = 1; }
  }
  
  a320_sound_stop();
    
  a320_timer_delete(gameTimer);
  
  gfx_term();
  control_term();

  return ref;
}
